=begin
#Power Cloud API

#IBM Power Cloud API for Power Hardware / Infrastructure

The version of the OpenAPI document: 1.0.0
Contact: kylej@us.ibm.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.0.0-beta2

=end

require 'cgi'

module IbmCloudPower
  class PCloudSnapshotsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a PVM instance snapshot of a cloud instance
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def pcloud_cloudinstances_snapshots_delete(cloud_instance_id, snapshot_id, opts = {})
      data, _status_code, _headers = pcloud_cloudinstances_snapshots_delete_with_http_info(cloud_instance_id, snapshot_id, opts)
      data
    end

    # Delete a PVM instance snapshot of a cloud instance
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def pcloud_cloudinstances_snapshots_delete_with_http_info(cloud_instance_id, snapshot_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_delete ...'
      end
      # verify the required parameter 'cloud_instance_id' is set
      if @api_client.config.client_side_validation && cloud_instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'cloud_instance_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_delete"
      end
      # verify the required parameter 'snapshot_id' is set
      if @api_client.config.client_side_validation && snapshot_id.nil?
        fail ArgumentError, "Missing the required parameter 'snapshot_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_delete"
      end
      # resource path
      local_var_path = '/pcloud/v1/cloud-instances/{cloud_instance_id}/snapshots/{snapshot_id}'.sub('{' + 'cloud_instance_id' + '}', CGI.escape(cloud_instance_id.to_s)).sub('{' + 'snapshot_id' + '}', CGI.escape(snapshot_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudSnapshotsApi#pcloud_cloudinstances_snapshots_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get the detail of a snapshot
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param [Hash] opts the optional parameters
    # @return [Snapshot]
    def pcloud_cloudinstances_snapshots_get(cloud_instance_id, snapshot_id, opts = {})
      data, _status_code, _headers = pcloud_cloudinstances_snapshots_get_with_http_info(cloud_instance_id, snapshot_id, opts)
      data
    end

    # Get the detail of a snapshot
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Snapshot, Integer, Hash)>] Snapshot data, response status code and response headers
    def pcloud_cloudinstances_snapshots_get_with_http_info(cloud_instance_id, snapshot_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_get ...'
      end
      # verify the required parameter 'cloud_instance_id' is set
      if @api_client.config.client_side_validation && cloud_instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'cloud_instance_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_get"
      end
      # verify the required parameter 'snapshot_id' is set
      if @api_client.config.client_side_validation && snapshot_id.nil?
        fail ArgumentError, "Missing the required parameter 'snapshot_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_get"
      end
      # resource path
      local_var_path = '/pcloud/v1/cloud-instances/{cloud_instance_id}/snapshots/{snapshot_id}'.sub('{' + 'cloud_instance_id' + '}', CGI.escape(cloud_instance_id.to_s)).sub('{' + 'snapshot_id' + '}', CGI.escape(snapshot_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Snapshot' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudSnapshotsApi#pcloud_cloudinstances_snapshots_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List all PVM instance snapshots for this cloud instance
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param [Hash] opts the optional parameters
    # @return [Snapshots]
    def pcloud_cloudinstances_snapshots_getall(cloud_instance_id, opts = {})
      data, _status_code, _headers = pcloud_cloudinstances_snapshots_getall_with_http_info(cloud_instance_id, opts)
      data
    end

    # List all PVM instance snapshots for this cloud instance
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param [Hash] opts the optional parameters
    # @return [Array<(Snapshots, Integer, Hash)>] Snapshots data, response status code and response headers
    def pcloud_cloudinstances_snapshots_getall_with_http_info(cloud_instance_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_getall ...'
      end
      # verify the required parameter 'cloud_instance_id' is set
      if @api_client.config.client_side_validation && cloud_instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'cloud_instance_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_getall"
      end
      # resource path
      local_var_path = '/pcloud/v1/cloud-instances/{cloud_instance_id}/snapshots'.sub('{' + 'cloud_instance_id' + '}', CGI.escape(cloud_instance_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Snapshots' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudSnapshotsApi#pcloud_cloudinstances_snapshots_getall\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a PVM instance snapshot
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param body [SnapshotUpdate] Parameters for the update of a PVM instance snapshot
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def pcloud_cloudinstances_snapshots_put(cloud_instance_id, snapshot_id, body, opts = {})
      data, _status_code, _headers = pcloud_cloudinstances_snapshots_put_with_http_info(cloud_instance_id, snapshot_id, body, opts)
      data
    end

    # Update a PVM instance snapshot
    # @param cloud_instance_id [String] Cloud Instance ID of a PCloud Instance
    # @param snapshot_id [String] PVM Instance snapshot id
    # @param body [SnapshotUpdate] Parameters for the update of a PVM instance snapshot
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def pcloud_cloudinstances_snapshots_put_with_http_info(cloud_instance_id, snapshot_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_put ...'
      end
      # verify the required parameter 'cloud_instance_id' is set
      if @api_client.config.client_side_validation && cloud_instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'cloud_instance_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_put"
      end
      # verify the required parameter 'snapshot_id' is set
      if @api_client.config.client_side_validation && snapshot_id.nil?
        fail ArgumentError, "Missing the required parameter 'snapshot_id' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PCloudSnapshotsApi.pcloud_cloudinstances_snapshots_put"
      end
      # resource path
      local_var_path = '/pcloud/v1/cloud-instances/{cloud_instance_id}/snapshots/{snapshot_id}'.sub('{' + 'cloud_instance_id' + '}', CGI.escape(cloud_instance_id.to_s)).sub('{' + 'snapshot_id' + '}', CGI.escape(snapshot_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudSnapshotsApi#pcloud_cloudinstances_snapshots_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
