=begin
#Power Cloud API

#IBM Power Cloud API for Power Hardware / Infrastructure

The version of the OpenAPI document: 1.0.0
Contact: kylej@us.ibm.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.0.0-beta2

=end

require 'cgi'

module IbmCloudPower
  class PCloudTenantsSSHKeysApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a tenant's SSH key
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def pcloud_tenants_sshkeys_delete(tenant_id, sshkey_name, opts = {})
      data, _status_code, _headers = pcloud_tenants_sshkeys_delete_with_http_info(tenant_id, sshkey_name, opts)
      data
    end

    # Delete a tenant&#39;s SSH key
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def pcloud_tenants_sshkeys_delete_with_http_info(tenant_id, sshkey_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_delete ...'
      end
      # verify the required parameter 'tenant_id' is set
      if @api_client.config.client_side_validation && tenant_id.nil?
        fail ArgumentError, "Missing the required parameter 'tenant_id' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_delete"
      end
      # verify the required parameter 'sshkey_name' is set
      if @api_client.config.client_side_validation && sshkey_name.nil?
        fail ArgumentError, "Missing the required parameter 'sshkey_name' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_delete"
      end
      # resource path
      local_var_path = '/pcloud/v1/tenants/{tenant_id}/sshkeys/{sshkey_name}'.sub('{' + 'tenant_id' + '}', CGI.escape(tenant_id.to_s)).sub('{' + 'sshkey_name' + '}', CGI.escape(sshkey_name.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudTenantsSSHKeysApi#pcloud_tenants_sshkeys_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get a tenant's SSH Key by name
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [SSHKey]
    def pcloud_tenants_sshkeys_get(tenant_id, sshkey_name, opts = {})
      data, _status_code, _headers = pcloud_tenants_sshkeys_get_with_http_info(tenant_id, sshkey_name, opts)
      data
    end

    # Get a tenant&#39;s SSH Key by name
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [Array<(SSHKey, Integer, Hash)>] SSHKey data, response status code and response headers
    def pcloud_tenants_sshkeys_get_with_http_info(tenant_id, sshkey_name, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_get ...'
      end
      # verify the required parameter 'tenant_id' is set
      if @api_client.config.client_side_validation && tenant_id.nil?
        fail ArgumentError, "Missing the required parameter 'tenant_id' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_get"
      end
      # verify the required parameter 'sshkey_name' is set
      if @api_client.config.client_side_validation && sshkey_name.nil?
        fail ArgumentError, "Missing the required parameter 'sshkey_name' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_get"
      end
      # resource path
      local_var_path = '/pcloud/v1/tenants/{tenant_id}/sshkeys/{sshkey_name}'.sub('{' + 'tenant_id' + '}', CGI.escape(tenant_id.to_s)).sub('{' + 'sshkey_name' + '}', CGI.escape(sshkey_name.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'SSHKey' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudTenantsSSHKeysApi#pcloud_tenants_sshkeys_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List a tenant's SSH Keys
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [SSHKeys]
    def pcloud_tenants_sshkeys_getall(tenant_id, opts = {})
      data, _status_code, _headers = pcloud_tenants_sshkeys_getall_with_http_info(tenant_id, opts)
      data
    end

    # List a tenant&#39;s SSH Keys
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param [Hash] opts the optional parameters
    # @return [Array<(SSHKeys, Integer, Hash)>] SSHKeys data, response status code and response headers
    def pcloud_tenants_sshkeys_getall_with_http_info(tenant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_getall ...'
      end
      # verify the required parameter 'tenant_id' is set
      if @api_client.config.client_side_validation && tenant_id.nil?
        fail ArgumentError, "Missing the required parameter 'tenant_id' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_getall"
      end
      # resource path
      local_var_path = '/pcloud/v1/tenants/{tenant_id}/sshkeys'.sub('{' + 'tenant_id' + '}', CGI.escape(tenant_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'SSHKeys' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudTenantsSSHKeysApi#pcloud_tenants_sshkeys_getall\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Add a new SSH key to the tenant
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param body [SSHKey] Parameters for the creation of a new SSH key
    # @param [Hash] opts the optional parameters
    # @return [SSHKey]
    def pcloud_tenants_sshkeys_post(tenant_id, body, opts = {})
      data, _status_code, _headers = pcloud_tenants_sshkeys_post_with_http_info(tenant_id, body, opts)
      data
    end

    # Add a new SSH key to the tenant
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param body [SSHKey] Parameters for the creation of a new SSH key
    # @param [Hash] opts the optional parameters
    # @return [Array<(SSHKey, Integer, Hash)>] SSHKey data, response status code and response headers
    def pcloud_tenants_sshkeys_post_with_http_info(tenant_id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_post ...'
      end
      # verify the required parameter 'tenant_id' is set
      if @api_client.config.client_side_validation && tenant_id.nil?
        fail ArgumentError, "Missing the required parameter 'tenant_id' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_post"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_post"
      end
      # resource path
      local_var_path = '/pcloud/v1/tenants/{tenant_id}/sshkeys'.sub('{' + 'tenant_id' + '}', CGI.escape(tenant_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'SSHKey' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudTenantsSSHKeysApi#pcloud_tenants_sshkeys_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an SSH Key
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param body [SSHKey] Parameters for updating a Tenant&#39;s SSH Key
    # @param [Hash] opts the optional parameters
    # @return [SSHKey]
    def pcloud_tenants_sshkeys_put(tenant_id, sshkey_name, body, opts = {})
      data, _status_code, _headers = pcloud_tenants_sshkeys_put_with_http_info(tenant_id, sshkey_name, body, opts)
      data
    end

    # Update an SSH Key
    # @param tenant_id [String] Tenant ID of a pcloud tenant
    # @param sshkey_name [String] SSH key name for a pcloud tenant
    # @param body [SSHKey] Parameters for updating a Tenant&#39;s SSH Key
    # @param [Hash] opts the optional parameters
    # @return [Array<(SSHKey, Integer, Hash)>] SSHKey data, response status code and response headers
    def pcloud_tenants_sshkeys_put_with_http_info(tenant_id, sshkey_name, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_put ...'
      end
      # verify the required parameter 'tenant_id' is set
      if @api_client.config.client_side_validation && tenant_id.nil?
        fail ArgumentError, "Missing the required parameter 'tenant_id' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_put"
      end
      # verify the required parameter 'sshkey_name' is set
      if @api_client.config.client_side_validation && sshkey_name.nil?
        fail ArgumentError, "Missing the required parameter 'sshkey_name' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling PCloudTenantsSSHKeysApi.pcloud_tenants_sshkeys_put"
      end
      # resource path
      local_var_path = '/pcloud/v1/tenants/{tenant_id}/sshkeys/{sshkey_name}'.sub('{' + 'tenant_id' + '}', CGI.escape(tenant_id.to_s)).sub('{' + 'sshkey_name' + '}', CGI.escape(sshkey_name.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      # return_type
      return_type = opts[:return_type] || 'SSHKey' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PCloudTenantsSSHKeysApi#pcloud_tenants_sshkeys_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
